
#property copyright "www.forexgeyser.com"
#property link      "http://www.forexgeyser.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 Silver
#property indicator_color4 Lime
#property indicator_color5 Red
/* // Educated!
#import "MT4.Geyser.dll"
   bool Activate(string a0, string a1, int a2, string a3, int a4, string a5);
   void GetLastErrorDescription(string a0);
   double func201(double a0);
   double func202(double a0, double a1);
   double func203(double a0, double a1, double a2);
   double func204(double a0, double a1, double a2, double a3);
#import
*/
extern string License = "";
bool gi_84 = FALSE; //
bool gi_88 = FALSE; //
string gs_92; //
int gi_100; //
double gd_104;
double gd_112;
double gd_120;
double gd_128;
int g_period_136 = 8;
int g_period_140 = 21;
int gi_144 = 1;
bool gi_148 = TRUE;
bool gi_152 = FALSE;
bool gi_156 = FALSE;
double g_ibuf_160[];
double g_ibuf_164[];
double g_ibuf_168[];
double g_ibuf_172[];
double g_ibuf_176[];
double gd_180 = 0.0;
double gd_188 = 0.0;
datetime g_time_196;
string gs_200;

int init() {
   IndicatorDigits(Digits + 1);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, g_ibuf_160);
   SetIndexDrawBegin(0, g_period_140);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, g_ibuf_164);
   SetIndexDrawBegin(1, g_period_140 + gi_144);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexBuffer(2, g_ibuf_168);
   SetIndexDrawBegin(2, g_period_140 + gi_144);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, 233);
   SetIndexBuffer(3, g_ibuf_172);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexArrow(4, 234);
   SetIndexBuffer(4, g_ibuf_176);
   gs_200 = "GeyserMACD";
   SetIndexLabel(2, "MACD");
   SetIndexLabel(3, "Signal");
   SetIndexLabel(4, "Histogr");
   IndicatorShortName(gs_200);
   gd_180 = 2.0 / (gi_144 + 1.0);
   gd_188 = 1.0 - gd_180;
   /* // Educated!
   if (IsDemo()) gi_100 = 1;
   else gi_100 = 2;
   if (AccountNumber() == 0) gi_84 = TRUE;
   gi_88 = Activate(TerminalPath(), "" + AccountNumber(), gi_100, License, 1, "GeyserMACD");
   gs_92 = "1231231231313311111111111111111111111111111111111111111111111111111111111111111111111111111111111";
   GetLastErrorDescription(gs_92);
   */
   return (0);
}

int deinit() {
   string l_name_0;
   for (int li_8 = ObjectsTotal() - 1; li_8 >= 0; li_8--) {
      l_name_0 = ObjectName(li_8);
      if (StringSubstr(l_name_0, 0, 19) == "GMACD") ObjectDelete(l_name_0);
   }
   return (0);
}

int start() {
   int li_0 = IndicatorCounted();

   /* // Educated!
   if (gi_84) {
      if (AccountNumber() == 0) {
         Comment("Connecting to license server...");
         return (0);
      }
      gi_84 = FALSE;
      if (IsDemo()) gi_100 = 1;
      else gi_100 = 2;
      gi_88 = Activate(TerminalPath(), "" + AccountNumber(), gi_100, License, 1, "GeyserMACD");
      gs_92 = "1231231231313311111111111111111111111111111111111111111111111111111111111111111111111111111111111";
      GetLastErrorDescription(gs_92);
      li_0 = 0;
   } else li_0 = IndicatorCounted();
   if (gi_88 == FALSE) {
      Comment(gs_92);
      return (0);
   }
   //gd_104 = func201(Close[0]);
   //gd_112 = func202(Close[0], Time[0]);
   //gd_120 = func203(Close[0], Time[0], Bid);
   //gd_128 = func204(Close[0], Time[0], Bid, Ask);
   //g_period_136 = gd_104;
   //g_period_140 = gd_112;
   //gi_144 = gd_120;
     Comment("License Activated");
   */
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   int li_4 = Bars - li_0;
   CalculateIndicator(li_0);
   for (int li_8 = li_4; li_8 >= 0; li_8--) {
      g_ibuf_160[li_8] = iMA(NULL, 0, g_period_136, 0, MODE_EMA, PRICE_CLOSE, li_8) - iMA(NULL, 0, g_period_140, 0, MODE_EMA, PRICE_CLOSE, li_8);
      g_ibuf_164[li_8] = gd_180 * g_ibuf_160[li_8] + gd_188 * (g_ibuf_164[li_8 + 1]);
      g_ibuf_168[li_8] = g_ibuf_160[li_8] - g_ibuf_164[li_8];
   }
   return (0);
}

void CalculateIndicator(int ai_0) {
   for (int li_4 = Bars - ai_0; li_4 >= 0; li_4--) {
      CalculateMACD(li_4);
      CatchBullishDivergence(li_4 + 2);
      CatchBearishDivergence(li_4 + 2);
   }
}

void CalculateMACD(int ai_0) {
   g_ibuf_160[ai_0] = iMA(NULL, 0, g_period_136, 0, MODE_EMA, PRICE_CLOSE, ai_0) - iMA(NULL, 0, g_period_140, 0, MODE_EMA, PRICE_CLOSE, ai_0);
   g_ibuf_164[ai_0] = gd_180 * g_ibuf_160[ai_0] + gd_188 * (g_ibuf_164[ai_0 + 1]);
   g_ibuf_168[ai_0] = g_ibuf_160[ai_0] - g_ibuf_164[ai_0];
}

void CatchBullishDivergence(int ai_0) {
   int li_4;
   int li_8;
   if (IsIndicatorTrough(ai_0) != 0) {
      li_4 = ai_0;
      li_8 = GetIndicatorLastTrough(ai_0);
      if (g_ibuf_160[li_4] > g_ibuf_160[li_8] && Low[li_4] < Low[li_8]) {
         g_ibuf_172[li_4] = g_ibuf_160[li_4] - gd_128;
         if (gi_152 == TRUE) DrawPriceTrendLine(Time[li_4], Time[li_8], Low[li_4], Low[li_8], Lime, STYLE_SOLID);
         if (gi_148 == TRUE) DrawIndicatorTrendLine(Time[li_4], Time[li_8], g_ibuf_160[li_4], g_ibuf_160[li_8], Lime, STYLE_SOLID);
         if (gi_156 == TRUE) DisplayAlert("Classical bullish divergence on: ", li_4);
      }
      if (g_ibuf_160[li_4] < g_ibuf_160[li_8] && Low[li_4] > Low[li_8]) {
         g_ibuf_172[li_4] = g_ibuf_160[li_4] - gd_128;
         if (gi_152 == TRUE) DrawPriceTrendLine(Time[li_4], Time[li_8], Low[li_4], Low[li_8], Lime, STYLE_DOT);
         if (gi_148 == TRUE) DrawIndicatorTrendLine(Time[li_4], Time[li_8], g_ibuf_160[li_4], g_ibuf_160[li_8], Lime, STYLE_DOT);
         if (gi_156 == TRUE) DisplayAlert("Reverse bullish divergence on: ", li_4);
      }
   }
}

void CatchBearishDivergence(int ai_0) {
   int li_4;
   int li_8;
   if (IsIndicatorPeak(ai_0) != 0) {
      li_4 = ai_0;
      li_8 = GetIndicatorLastPeak(ai_0);
      if (g_ibuf_160[li_4] < g_ibuf_160[li_8] && High[li_4] > High[li_8]) {
         g_ibuf_176[li_4] = g_ibuf_160[li_4] + gd_128;
         if (gi_152 == TRUE) DrawPriceTrendLine(Time[li_4], Time[li_8], High[li_4], High[li_8], Red, STYLE_SOLID);
         if (gi_148 == TRUE) DrawIndicatorTrendLine(Time[li_4], Time[li_8], g_ibuf_160[li_4], g_ibuf_160[li_8], Red, STYLE_SOLID);
         if (gi_156 == TRUE) DisplayAlert("Classical bearish divergence on: ", li_4);
      }
      if (g_ibuf_160[li_4] > g_ibuf_160[li_8] && High[li_4] < High[li_8]) {
         g_ibuf_176[li_4] = g_ibuf_160[li_4] + gd_128;
         if (gi_152 == TRUE) DrawPriceTrendLine(Time[li_4], Time[li_8], High[li_4], High[li_8], Red, STYLE_DOT);
         if (gi_148 == TRUE) DrawIndicatorTrendLine(Time[li_4], Time[li_8], g_ibuf_160[li_4], g_ibuf_160[li_8], Red, STYLE_DOT);
         if (gi_156 == TRUE) DisplayAlert("Reverse bearish divergence on: ", li_4);
      }
   }
}

int IsIndicatorPeak(int ai_0) {
   if (g_ibuf_160[ai_0] >= g_ibuf_160[ai_0 + 1] && g_ibuf_160[ai_0] > g_ibuf_160[ai_0 + 2] && g_ibuf_160[ai_0] > g_ibuf_160[ai_0 - 1]) return (1);
   return (0);
}

int IsIndicatorTrough(int ai_0) {
   if (g_ibuf_160[ai_0] <= g_ibuf_160[ai_0 + 1] && g_ibuf_160[ai_0] < g_ibuf_160[ai_0 + 2] && g_ibuf_160[ai_0] < g_ibuf_160[ai_0 - 1]) return (1);
   return (0);
}

int GetIndicatorLastPeak(int ai_0) {
   for (int li_4 = ai_0 + 5; li_4 < Bars; li_4++) {
      if (g_ibuf_164[li_4] >= g_ibuf_164[li_4 + 1] && g_ibuf_164[li_4] >= g_ibuf_164[li_4 + 2] && g_ibuf_164[li_4] >= g_ibuf_164[li_4 - 1] && g_ibuf_164[li_4] >= g_ibuf_164[li_4 - 2]) {
         for (int li_ret_8 = li_4; li_ret_8 < Bars; li_ret_8++)
            if (g_ibuf_160[li_ret_8] >= g_ibuf_160[li_ret_8 + 1] && g_ibuf_160[li_ret_8] > g_ibuf_160[li_ret_8 + 2] && g_ibuf_160[li_ret_8] >= g_ibuf_160[li_ret_8 - 1] && g_ibuf_160[li_ret_8] > g_ibuf_160[li_ret_8 - 2]) return (li_ret_8);
      }
   }
   return (-1);
}

int GetIndicatorLastTrough(int ai_0) {
   for (int li_4 = ai_0 + 5; li_4 < Bars; li_4++) {
      if (g_ibuf_164[li_4] <= g_ibuf_164[li_4 + 1] && g_ibuf_164[li_4] <= g_ibuf_164[li_4 + 2] && g_ibuf_164[li_4] <= g_ibuf_164[li_4 - 1] && g_ibuf_164[li_4] <= g_ibuf_164[li_4 - 2]) {
         for (int li_ret_8 = li_4; li_ret_8 < Bars; li_ret_8++)
            if (g_ibuf_160[li_ret_8] <= g_ibuf_160[li_ret_8 + 1] && g_ibuf_160[li_ret_8] < g_ibuf_160[li_ret_8 + 2] && g_ibuf_160[li_ret_8] <= g_ibuf_160[li_ret_8 - 1] && g_ibuf_160[li_ret_8] < g_ibuf_160[li_ret_8 - 2]) return (li_ret_8);
      }
   }
   return (-1);
}

void DisplayAlert(string as_0, int ai_8) {
   if (ai_8 <= 2 && Time[ai_8] != g_time_196) {
      g_time_196 = Time[ai_8];
      Alert(as_0, Symbol(), " , ", Period(), " minutes chart");
   }
}

void DrawPriceTrendLine(int a_datetime_0, int a_datetime_4, double a_price_8, double a_price_16, color a_color_24, double a_style_28) {
   string l_name_36 = "GMACD.0# " + DoubleToStr(a_datetime_0, 0);
   ObjectDelete(l_name_36);
   ObjectCreate(l_name_36, OBJ_TREND, 0, a_datetime_0, a_price_8, a_datetime_4, a_price_16, 0, 0);
   ObjectSet(l_name_36, OBJPROP_RAY, FALSE);
   ObjectSet(l_name_36, OBJPROP_COLOR, a_color_24);
   ObjectSet(l_name_36, OBJPROP_STYLE, a_style_28);
}

void DrawIndicatorTrendLine(int a_datetime_0, int a_datetime_4, double a_price_8, double a_price_16, color a_color_24, double a_style_28) {
   string l_name_36;
   int l_window_44 = WindowFind(gs_200);
   if (l_window_44 >= 0) {
      l_name_36 = "GMACD.0$# " + DoubleToStr(a_datetime_0, 0);
      ObjectDelete(l_name_36);
      ObjectCreate(l_name_36, OBJ_TREND, l_window_44, a_datetime_0, a_price_8, a_datetime_4, a_price_16, 0, 0);
      ObjectSet(l_name_36, OBJPROP_RAY, FALSE);
      ObjectSet(l_name_36, OBJPROP_COLOR, a_color_24);
      ObjectSet(l_name_36, OBJPROP_STYLE, a_style_28);
   }
}